<?php

/**
 * Enderecoparc
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    DbModel
 * @subpackage Model
 * @author     cristianefaria - 10/02/2012 14:59:41 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Enderecoparc extends DaoEnderecoparc
{
	
	public static function novoCodigo(){
		
		return Novocodigo::geraCodigo(Ambiente::getNrorg(), 'ENDERECOPARC', 1, 21, true);
			
	}
	
	public static function verificaSeENovo($nrenderecoparc){
		
		$sql = "select cdtipoendereco from enderecoparc where nrenderecoparc = ".$nrenderecoparc." and nrorg = ".Ambiente::getNrorg();
		$result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
		
		return $result;
		
	}
	
	public static function deleta_filho_enderecoparc($nrenderecoparc){		
		
		try{
			
			$db = Setforms2\Runtime\Connection::getInstance();
			$db->getConn()->beginTransaction();
			
			$endeclie = "delete from endeclie where nrenderecoparc = ".$nrenderecoparc." and nrorg = ".Ambiente::getNrorg();
			\Setforms2\Runtime\Connection::getInstance()->execute($endeclie);
			
			$endeforn = "delete from endeforn where nrenderecoparc = ".$nrenderecoparc." and nrorg = ".Ambiente::getNrorg();		
			\Setforms2\Runtime\Connection::getInstance()->execute($endeforn);
			
			$endeprospect = "delete from endeprospect where nrenderecoparc = ".$nrenderecoparc." and nrorg = ".Ambiente::getNrorg();
			\Setforms2\Runtime\Connection::getInstance()->execute($endeprospect);
			
			
			$db->getConn()->commit();
			
		}catch(Exception $e){
			throw $e;
		}
			
	}	
	
	public static function validaCdTipoEndereco($nrparcnegocio, $nrenderecoparc, $novoisnull = null){
		try{
                    $sql = "select cdtipoendereco from enderecoparc where nrparcnegocio = ".$nrparcnegocio." and nrorg = ".Ambiente::getNrorg();
                    if ($novoisnull != null){
                            $sql .= " and nrenderecoparc = ".$nrenderecoparc;
                    }
                    $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);

                    return $result;    
                }catch(Exception $e){
                    throw $e;
                }
		
		
	}


    /**
     * Retorna uma instancia de EnderecoparcEntity
     *
     * @param string $nrEnderecoParc Numero do EnderecoParc.
     * @param string $nrOrg          Numero da Organizacao.
     *
     * @return EnderecoparcEntity | null
     *
     * @author thalesvalias - 02/04/2012
     */
    public static function retornaEnderecoParceiro($nrEnderecoParc, $nrOrg){

        $resultado = self::getObjectByWhere(
            'NRENDERECOPARC = ? AND NRORG = ?',
            array(
                $nrEnderecoParc, $nrOrg,
            ));

        return $resultado;

    }


    /**
     * Retorna uma instancia de EnderecoparcEntity por tipo de endereco
     *
     * @param integer $nrOrg        Numero da Organizacao.
     * @param integer $nrParceiro   Numero do EnderecoParc.
     * @param string  $tipoEndereco Tipo de endereco.
     *
     * @return EnderecoparcEntity | null
     *
     * @author thalesvalias - 12/04/2012
     */
    public static function retornaEnderecoParceiroPorTipo($nrOrg, $nrParceiro, $tipoEndereco){

        $resultado = self::getObjectByWhere(
            'NRORG = ?
            AND NRPARCNEGOCIO = ?
            AND CDTIPOENDERECO = ?',
            array(
                 $nrOrg, $nrParceiro, $tipoEndereco,
            )
        );

        return $resultado;

    }

    public static function consultaEnderecoPorCep($cep, $nrorg)
    {
        try{
            $sql = <<<SQL
                SELECT * FROM (
                  SELECT E.DSENDERECO,
                    E.CDPAIS,
                    E.SGESTADO,
                    E.CDMUNICIPIO,
                    M.NMMUNICIPIO,
                    E.CDBAIRRO,
                    B.NMBAIRRO,
                    E.CDLOGRADOURO,
                    REPLACE(E.NRCEPENDERECO,'-','') as NRCEPENDERECO
                  FROM ENDERECOPARC E
                  LEFT JOIN MUNICIPIO M
                  ON (E.CDPAIS       = M.CDPAIS)
                  AND (E.SGESTADO    = M.SGESTADO)
                  AND (E.CDMUNICIPIO = M.CDMUNICIPIO)
                  LEFT JOIN BAIRRO B
                  ON (E.CDPAIS       = B.CDPAIS)
                  AND (E.SGESTADO    = B.SGESTADO)
                  AND (E.CDMUNICIPIO = B.CDMUNICIPIO)
                  AND (E.CDBAIRRO    = B.CDBAIRRO)
                ) ENDERECOPARC
                WHERE NRCEPENDERECO = ?
                AND NRORG = ?
SQL;
            $params = array($cep, $nrorg);

            return \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql, $params);
        } catch(PDOException $e) {
            throw $e;
        }
    }

    public static function retornaQuerySearchEndereco()
    {
        $sql = <<<SQL
        SELECT * FROM (
          SELECT E.DSENDERECO,
            E.CDPAIS,
            E.SGESTADO,
            E.CDMUNICIPIO,
            M.NMMUNICIPIO,
            E.CDBAIRRO,
            B.NMBAIRRO,
            E.CDLOGRADOURO,
            REPLACE(E.NRCEPENDERECO,'-','') as NRCEPENDERECO
          FROM ENDERECOPARC E
          LEFT JOIN MUNICIPIO M
          ON (E.CDPAIS       = M.CDPAIS)
          AND (E.SGESTADO    = M.SGESTADO)
          AND (E.CDMUNICIPIO = M.CDMUNICIPIO)
          LEFT JOIN BAIRRO B
          ON (E.CDPAIS       = B.CDPAIS)
          AND (E.SGESTADO    = B.SGESTADO)
          AND (E.CDMUNICIPIO = B.CDMUNICIPIO)
          AND (E.CDBAIRRO    = B.CDBAIRRO)
        ) ENDERECOPARC
SQL;

        return $sql;
    }
}
